Subject: Re: bug#23273: Error using windows 10 bash error 0x53464846 doing a tail -f
From: Pádraig Brady <[email-masked]>
To: Bernhard Voelker <[email-masked]>, Dennis J <[email-masked]>, [email-masked]
Date: Thu, 21 Apr 2016 21:57:40 +0100
List-Id: <debbugs-submit.debbugs.gnu.org>

On 12/04/16 09:11, Bernhard Voelker wrote:
> On 04/12/2016 01:54 AM, Pádraig Brady wrote:
>> On 11/04/16 23:37, Dennis J wrote:
>>> I'm getting this error when doing a tail -f on a simple text file.
>>> tail: unrecognized file system type 0x53464846 for ‘kn.txt’. please report this to [email-masked]. reverting to polling
>>
>> Interesting. What do we call this win_bashfs or something?
>
> There's not much technical information available, but shouldn't
> that "Windows Subsystem for Linux" (WSL) just pass on some NTFS?
> It's not clear to me whether the entry point is a modified bash,
> library or whatever, so bash may not always be involved here.
> Therefore, I'd say "wsl_fs" or "wsl_ntfs" may be a valid name.
>
>> Since there is just a single kernel involved, I'm guessing
>> that we don't need to tag this as a "remote" file system,
>> and that inotify calls will fail/succeed as appropriate.
>> That could be confirmed using the inotifywait command as detailed at:
>> http://bugs.gnu.org/23143#11
>
> WSL is in early beta, so I wouldn't expect inotify to work.

Should be no harm trying though I expect.
I went with "wslfs" as underscores are the exception in names.

I'll push the attached later.

cheers,
Pádraig
From 60700f11ed3d3ca320ce74ad2f9f0d0446ad8934 Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?P=C3=A1draig=20Brady?= <[email-masked]>
Date: Thu, 21 Apr 2016 21:48:50 +0100
Subject: [PATCH] stat,tail: add support for WSLFS

* src/stat.c (human_fstype): Add file system ID definition.
* NEWS (Improvements): Mention the change.
Fixes http://bugs.gnu.org/23273
---
 NEWS       | 8 ++++----
 src/stat.c | 2 ++
 2 files changed, 6 insertions(+), 4 deletions(-)

diff --git a/NEWS b/NEWS
index 4cb5caf..189a03a 100644
--- a/NEWS
+++ b/NEWS
@@ -30,10 +30,10 @@ GNU coreutils NEWS                                    -*- outline -*-
 
 ** Improvements
 
-   stat and tail now know about "prl_fs" (a parallels file system), and
-   "m1fs" (a Plexistor file system).  stat -f --format=%T now reports the
-   file system type, and tail -f uses the more conservative polling for
-   "prl_fs", and inotify for "m1fs" file systems.
+   stat and tail now know about "prl_fs" (a parallels file system),
+   "m1fs" (a Plexistor file system), and "wslfs" (Windows Subsystem for Linux).
+   stat -f --format=%T now reports the file system type, and tail -f uses
+   polling for "prl_fs", inotify for "m1fs", and attempts inotify for "wslfs".

 * Noteworthy changes in release 8.25 (2016-01-20) [stable]
diff --git a/src/stat.c b/src/stat.c
index ab69fbe..7a20ff7 100644
--- a/src/stat.c
+++ b/src/stat.c
@@ -470,6 +470,8 @@ human_fstype (STRUCT_STATVFS const *statfsbuf)
       return "vxfs";
     case S_MAGIC_VZFS: /* 0x565A4653 local */
       return "vzfs";
+    case S_MAGIC_WSLFS: /* 0x53464846 local */
+      return "wslfs";
     case S_MAGIC_XENFS: /* 0xABBA1974 local */
       return "xenfs";
     case S_MAGIC_XENIX: /* 0x012FF7B4 local */
-- 
2.5.5